// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "SimpleUI.h"
#include "ChildView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CChildView

CChildView::CChildView()
{
	m_textColor=RGB(0,0,0);  //black
	m_bgColor=RGB(255,255,255);  //white
	m_textPoint=DT_LEFT;
	m_strOutText ="޴ ";
}

CChildView::~CChildView()
{
}

BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_COMMAND(ID_TEXTCOLOR_RED, &CChildView::OnTextColorRed)
	ON_COMMAND(ID_TEXTCOLOR_GREEN, &CChildView::OnTextColorGreen)
	ON_COMMAND(ID_TEXTCOLOR_BLUE, &CChildView::OnTextColorBlue)
	ON_COMMAND(ID_TEXTCOLOR_BLACK, &CChildView::OnTextColorBlack)
	ON_COMMAND(ID_BGCOLOR_RED, &CChildView::OnBgColorRed)
	ON_COMMAND(ID_BGCOLOR_GREEN, &CChildView::OnBgColorGreen)
	ON_COMMAND(ID_BGCOLOR_BLUE, &CChildView::OnBgColorBlue)
	ON_COMMAND(ID_BGCOLOR_WHITE, &CChildView::OnBgColorWhite)
	ON_UPDATE_COMMAND_UI(ID_TEXTCOLOR_RED, &CChildView::OnUpdateTextColorRed)
	ON_UPDATE_COMMAND_UI(ID_TEXTCOLOR_GREEN, &CChildView::OnUpdateTextColorGreen)
	ON_UPDATE_COMMAND_UI(ID_TEXTCOLOR_BLUE, &CChildView::OnUpdateTextColorBlue)
	ON_UPDATE_COMMAND_UI(ID_TEXTCOLOR_BLACK, &CChildView::OnUpdateTextColorBlack)
	ON_COMMAND(ID_ALIGNMENT_LEFT, &CChildView::OnAlignmentLeft)
	ON_COMMAND(ID_ALIGNMENT_CENTER, &CChildView::OnAlignmentCenter)
	ON_COMMAND(ID_ALIGNMENT_RIGHT, &CChildView::OnAlignmentRight)
	ON_COMMAND(ID_POPUP1, &CChildView::OnAlignmentLeft)
	ON_COMMAND(ID_POPUP2, &CChildView::OnAlignmentCenter)
	ON_COMMAND(ID_POPUP3, &CChildView::OnAlignmentRight)
	ON_COMMAND(ID_BUTTON1, &CChildView::OnAlignmentLeft)
	ON_COMMAND(ID_BUTTON2, &CChildView::OnAlignmentCenter)
	ON_COMMAND(ID_BUTTON3, &CChildView::OnAlignmentRight)
	ON_WM_CONTEXTMENU()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()


// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here

    CRect rect;
    GetClientRect(&rect);
    CBrush brush(m_bgColor);
    dc.SelectStockObject(NULL_PEN);	// 
    dc.SelectObject(&brush);		// 
    dc.Rectangle(&rect);    

	CFont *pOldFont, newFont;
	newFont.CreatePointFont(400, "Arial"); //(400/10) 40point
	pOldFont = dc.SelectObject(&newFont);

	dc.SetTextColor(m_textColor); //ڻ 
	dc.SetBkColor(m_bgColor); //  

	dc.DrawText(m_strOutText,rect, m_textPoint);

	dc.SelectObject(pOldFont);
	
	// Do not call CWnd::OnPaint() for painting messages
}


void CChildView::OnTextColorRed()
{
	// TODO: Add your command handler code here
	m_textColor = RGB(255, 0, 0);
	Invalidate();
}

void CChildView::OnTextColorGreen()
{
	// TODO: Add your command handler code here
	m_textColor = RGB(0, 255, 0);
	Invalidate();
}

void CChildView::OnTextColorBlue()
{
	// TODO: Add your command handler code here
	m_textColor = RGB(0, 0, 255);
	Invalidate();
}

void CChildView::OnTextColorBlack()
{
	// TODO: Add your command handler code here
	m_textColor = RGB(0, 0, 0);
	Invalidate();
}

void CChildView::OnBgColorRed()
{
	// TODO: Add your command handler code here
	m_bgColor = RGB(255, 0, 0);
	Invalidate();
}

void CChildView::OnBgColorGreen()
{
	// TODO: Add your command handler code here
	m_bgColor = RGB(0, 255, 0);
	Invalidate();
}

void CChildView::OnBgColorBlue()
{
	// TODO: Add your command handler code here
	m_bgColor = RGB(0, 0, 255);
	Invalidate();
}

void CChildView::OnBgColorWhite()
{
	// TODO: Add your command handler code here
	m_bgColor = RGB(255, 255, 255);
	Invalidate();
}

void CChildView::OnUpdateTextColorRed(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_textColor == RGB(255, 0, 0));
}

void CChildView::OnUpdateTextColorGreen(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_textColor == RGB(0, 255, 0));
}

void CChildView::OnUpdateTextColorBlue(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_textColor == RGB(0, 0, 255));
}

void CChildView::OnUpdateTextColorBlack(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_textColor == RGB(0, 0, 0));
}

void CChildView::OnAlignmentLeft()
{
	// TODO: Add your command handler code here
	m_textPoint = DT_LEFT;
	Invalidate();
}

void CChildView::OnAlignmentCenter()
{
	// TODO: Add your command handler code here
	m_textPoint = DT_CENTER;
	Invalidate();
}

void CChildView::OnAlignmentRight()
{
	// TODO: Add your command handler code here
	m_textPoint = DT_RIGHT;
	Invalidate();
}

void CChildView::OnContextMenu(CWnd* pWnd, CPoint point)
{
	// TODO: Add your message handler code here
	// 1. ޴ Practice 
	/*
	CMenu menu;
	menu.LoadMenu(IDR_MAINFRAME);
	CMenu* pMenu = menu.GetSubMenu(3);
	pMenu->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x, point.y, AfxGetMainWnd()); 
	*/

	// 2. Pop-up ޴ 
	CMenu menu;
	menu.CreatePopupMenu();  //˾޴ 
	menu.AppendMenu(MF_STRING, ID_POPUP1, " ");
	menu.AppendMenu(MF_STRING, ID_POPUP2, " ");   //3 ޴׸ ߰
	menu.AppendMenu(MF_STRING, ID_POPUP3, " ");
   	//޴ ؽƮ ˾޴ ǥ
   	menu.TrackPopupMenu(TPM_LEFTALIGN, point.x, point.y, AfxGetMainWnd()); 
}

// 콺ӿ   ¹ nIndex=1 ҿ ڿ
void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	//View MainFrameü  
	CMainFrame *pFrame = (CMainFrame *) AfxGetMainWnd();
	CString strStatus;
	strStatus.Format("콺 X:%d, Y:%d ", point.x, point.y);
	// ¹ nIndex=1 ҿ ڿ   
	pFrame->m_wndStatusBar.SetPaneText(1, strStatus);  	

  	CWnd::OnMouseMove(nFlags, point);
}
